/*
 * Copyright (C) 2004-2012 Geometer Plus <contact@geometerplus.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
 * 02110-1301, USA.
 */

#include <tqlayout.h>
#include <tqpushbutton.h>

#include <ZLDialogManager.h>

#include "ZLTQtOptionsDialog.h"
#include "ZLTQtDialogContent.h"
#include "ZLTQtUtil.h"

ZLTQtOptionsDialog::ZLTQtOptionsDialog(const ZLResource &resource, shared_ptr<ZLRunnable> applyAction, bool showApplyButton) : TQTabDialog(0, 0, true), ZLDesktopOptionsDialog(resource, applyAction) {
	setCaption(::qtString(ZLOptionsDialog::caption()));
	setOkButton(::qtButtonName(ZLDialogManager::OK_BUTTON));
	setHelpButton(::qtButtonName(ZLDialogManager::CANCEL_BUTTON));
	connect(this, TQ_SIGNAL(helpButtonPressed()), this, TQ_SLOT(reject()));
	if (showApplyButton) {
		setApplyButton(::qtButtonName(ZLDialogManager::APPLY_BUTTON));
		connect(this, TQ_SIGNAL(applyButtonPressed()), this, TQ_SLOT(apply()));
	}
}

void ZLTQtOptionsDialog::apply() {
	ZLOptionsDialog::accept();
}

ZLDialogContent &ZLTQtOptionsDialog::createTab(const ZLResourceKey &key) {
	ZLTQtDialogContent *tab = new ZLTQtDialogContent(this, tabResource(key));
	addTab(tab->widget(), ::qtString(tab->displayName()));
	myTabs.push_back(tab);
	return *tab;
}

const std::string &ZLTQtOptionsDialog::selectedTabKey() const {
	TQWidget *currentTab = currentPage();
	for (std::vector<shared_ptr<ZLDialogContent> >::const_iterator it = myTabs.begin(); it != myTabs.end(); ++it) {
		if (((ZLTQtDialogContent&)**it).widget() == currentTab) {
			return (*it)->key();
		}
	}
	return myTabs[0]->key();
}

void ZLTQtOptionsDialog::selectTab(const ZLResourceKey &key) {
	for (std::vector<shared_ptr<ZLDialogContent> >::const_iterator it = myTabs.begin(); it != myTabs.end(); ++it) {
		if ((*it)->key() == key.Name) {
			showPage(((ZLTQtDialogContent&)**it).widget());
			break;
		}
	}
}

bool ZLTQtOptionsDialog::runInternal() {
	for (std::vector<shared_ptr<ZLDialogContent> >::iterator it = myTabs.begin(); it != myTabs.end(); ++it) {
		((ZLTQtDialogContent&)**it).close();
	}
	return exec() == TQDialog::Accepted;
}

void ZLTQtOptionsDialog::resizeEvent(TQResizeEvent *event) {
	TQTabDialog::resizeEvent(event);
	emit resized(event->size());
}

#include "ZLTQtOptionsDialog.moc"
